package com.example.postest;

import android.app.Activity;
import android.content.ComponentName;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;

import com.google.gson.Gson;

import java.util.ArrayList;
import java.util.List;

import butterknife.ButterKnife;
import butterknife.OnClick;

public class MainActivity extends AppCompatActivity {

    public static final String TAG = "qwer";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        ButterKnife.bind(this);
    }

    // 获取接口返回结果
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {

        switch (resultCode) {
            case Activity.RESULT_CANCELED:
                String reason = data.getStringExtra("result");
                //从result中解析对应字段
                Log.d(TAG, "onActivityResult: =" + reason);
                Toast.makeText(this, reason, Toast.LENGTH_SHORT).show();
                break;
            case Activity.RESULT_OK:
                String result = data.getStringExtra("result");
                //从result中解析对应字段
                Log.d(TAG, "onActivityResult: =" + result);
                Toast.makeText(this, result, Toast.LENGTH_SHORT).show();
                break;
            default:
        }
        super.onActivityResult(requestCode, resultCode, data);
    }

    @OnClick({R.id.btn_barcode_pay, R.id.btn_refund, R.id.btn_union_payment, R.id.btn_sign, R.id.btn_query_balance, R.id.btn_print_last, R.id.btn_query_order, R.id.btn_settle, R.id.btn_return, R.id.btn_print_custom_ticket})
    public void onViewClicked(View view) {
        switch (view.getId()) {
            case R.id.btn_barcode_pay:
                barcodePay();
                break;
            case R.id.btn_refund:
                refund();
                break;
            case R.id.btn_union_payment:
                unionPay();
                break;
            case R.id.btn_sign:
                sign();
                break;
            case R.id.btn_query_balance:
                queryBalance();
                break;
            case R.id.btn_print_last:
                printLast();
                break;
            case R.id.btn_query_order:
                queryOrder();
                break;
            case R.id.btn_settle:
                settle();
                break;
            case R.id.btn_return:
                uninoRefund();
                break;
            case R.id.btn_print_custom_ticket:
                printCustomTicket();
                break;
            default:
        }
    }

    private void barcodePay() {
        Bundle bundle = new Bundle();
        bundle.putString("pay_type", "000");
        bundle.putString("total_fee", "1");
        bundle.putString("terminal_trace", "000");
        bundle.putString("terminal_time", "20190716111213");
//        bundle.putString("show_result", "1");
//        bundle.putString("sub_appid", "as121krpmasfkmaspq12312");
//        bundle.putString("order_body", "测试订单内容备注");
//        bundle.putString("attach", "attach001");

////      bundle.putString("goods_detail", "[{\"goods_id\":\"619969\",\"goods_name\":\"玉兰油OLAY美肌滋润沐浴乳-深润滋养900毫 \",\"price\":\"3218\",\"quantity\":\"1\"}]");
//        List<GoodDetailBean> goodDetailBeans = new ArrayList<>();
//        goodDetailBeans.add(new GoodDetailBean("619969", "玉兰油OLAY美肌滋润沐浴乳-深润滋养900毫", "3218", "1"));
//        bundle.putString("goods_detail", new Gson().toJson(goodDetailBeans));

//        bundle.putString("goods_tag", "cs");

        start(bundle, "cn.lcsw.lcpos.activity.Exported_PayFunc_Activity");
    }

    private void refund() {
        Bundle bundle = new Bundle();
        bundle.putString("pay_type", "000");
        bundle.putString("refund_fee", "1");
        bundle.putString("out_trade_no", "112566026122119071611595816422");
        bundle.putString("show_result", "1");
        start(bundle, "cn.lcsw.lcpos.activity.Exported_RefundFunc_Activity");
    }

    private void unionPay() {
        Bundle bundle = new Bundle();

        //消费
        bundle.putString("type", "SALE");

        //撤销
//        bundle.putString("type", "VOID");
//        bundle.putString("terminal_trace", "100455");//凭证号

        bundle.putString("total_fee", "1");
        bundle.putString("show_result", "1");


        start(bundle, "cn.lcsw.lcpos.activity.Exported_UnionFunc_Activity");
    }

    private void sign() {
        Bundle bundle = new Bundle();
        bundle.putString("type", "SIGN");
        start(bundle, "cn.lcsw.lcpos.activity.Exported_UnionFunc_Activity");
    }

    private void queryBalance() {
        Bundle bundle = new Bundle();
        bundle.putString("type", "BALANCE");
        start(bundle, "cn.lcsw.lcpos.activity.Exported_UnionFunc_Activity");
    }

    private void printLast() {
        Bundle bundle = new Bundle();
        bundle.putString("type", "LAST");
        start(bundle, "cn.lcsw.lcpos.activity.Exported_UnionFunc_Activity");
    }

    private void queryOrder() {
        Bundle bundle = new Bundle();
        bundle.putString("type", "NETQUERY");
        bundle.putString("old_trace", "100455");//凭证号terminal_trace
        bundle.putString("data", "0718");
        bundle.putString("order_number", "181059873002");//参考号out_trade_no
        start(bundle, "cn.lcsw.lcpos.activity.Exported_UnionFunc_Activity");
    }

    private void settle() {
        Bundle bundle = new Bundle();
        bundle.putString("type", "SETTLE");
//        bundle.putString("is_print", "true");
        start(bundle, "cn.lcsw.lcpos.activity.Exported_UnionFunc_Activity");
    }

    private void uninoRefund() {
        Bundle bundle = new Bundle();
        bundle.putString("type", "REFUND");
        bundle.putString("total_fee", "1");
        start(bundle, "cn.lcsw.lcpos.activity.Exported_UnionFunc_Activity");
    }

    private void printCustomTicket() {
        Bundle bundle = new Bundle();

//        String content = "{\"spos\":[{\"position\":\"center\",\"content\":\"POS签购单\",\"content-type\":\"txt\",\"bold\":\"0\",\"height\":\"-1\",\"italic\":\"0\",\"offset\":\"0\",\"size\":\"3\"},{\"position\":\"left\",\"content\":\"请妥善保管\",\"content-type\":\"txt\",\"bold\":\"0\",\"height\":\"-1\",\"italic\":\"0\",\"offset\":\"0\",\"size\":\"1\"}]}";

        List<PrintBean.SposBean> sposBeans = new ArrayList<>();

        sposBeans.add(new PrintBean.SposBean("center", "POS签购单", "txt", "0", "1", "0", "0", "3"));
        sposBeans.add(new PrintBean.SposBean("left", "请妥善保管", "txt", "0", "-1", "0", "0", "1"));
        sposBeans.add(new PrintBean.SposBean("center", "http://www.lcsw.cn/doc/", "two-dimension", "0", "1", "0", "0", "3"));
        sposBeans.add(new PrintBean.SposBean("left", "发卡行:               04105840", "txt", "0", "-1", "0", "0", "2"));

        PrintBean content = new PrintBean(sposBeans);

        bundle.putString("print_content", new Gson().toJson(content));

        start(bundle, "cn.lcsw.lcpos.activity.Exported_PrintFunc_Activity");
    }

    private void start(Bundle bundle, String clazzName) {

        Intent intent = new Intent();
        intent.putExtras(bundle);

        ComponentName componentname = new ComponentName("cn.lcsw.lcpos", clazzName);
        intent.setComponent(componentname);

        if (intent.resolveActivity(this.getPackageManager()) != null) {
            this.startActivityForResult(intent, 0);
        }

    }
}
